#ifndef _COURSE_H
#define _COURSE_H

#include <string>
#include <fstream>

using namespace std;

class Course // version 1
{ //I: (strlen(cCode) == cCodeSz-1) && (strlen(cTitle) < cTitleSz) &&
// (1 <= cFSem <= 8) && (cSector in  {'','','','',''})  &&
// (cCateg in  {"","","",""})  && (cWH >= 0) &&
// (cUnits >= 0) && (strlen(cPrereq) == cCodeSz-1) && (cNoOfStudents >= 0)
public:
   enum { cCodeSz = 8, cTitleSz = 80, cCategSz = 4 };
   struct CourseKey
   {
      char s[cCodeSz];
      explicit CourseKey( string aKey="" )
      {  strncpy( s, aKey.c_str(), cCodeSz-1 );
         s[cCodeSz-1] = '\0';  }
   }; // CourseKey
   explicit Course( string aCode="", string aTitle="" );
   ~Course() { };
// getters
   const char* getCode() const {  return cCode.s;  }
   const char* getTitle() const {  return cTitle;  }
   unsigned int getFSem() const {  return cFSem;  }
   bool getCompuls() const {  return cCompuls;  }
   char getSector() const {  return cSector;  }
   const char* geCateg() const {  return cCateg;  }
   unsigned int getWH() const {  return cWH;  }
   unsigned int getUnits() const {  return cUnits;  }
   unsigned int getNoOfStudents() const {  return cNoOfStudents;  }
   const char* getPrereq() const {  return cPrereq.s;  }
// setters
   void setCode( string aCode );
   void setTitle( string aTitle );
   void setFSem( int aFSem );
   void setCompuls( bool aCompuls ) {  cCompuls = aCompuls;  };
   void setSector( char aSector );
   void setCateg( string aCateg );
   void setWH( int aWH );
   void setUnits( int aUnits );
   void clearStudents() {  cNoOfStudents = 0;  }
   void add1Student() {  ++cNoOfStudents;  }
   void delete1Student();
   void setPrereq( const string& prCode );
// other
   void save( ostream& bout ) const;
   void load( istream& bin );
   void display( ostream& tout ) const;
   
private:
   enum { cSaveSize = cCodeSz + cTitleSz + sizeof(int) +
                      sizeof(bool)+ sizeof(char) + cCategSz +
                      sizeof(int) + sizeof(int) + cCodeSz +
                      sizeof(int) };
   CourseKey    cCode;            //  
   char         cTitle[cTitleSz]; //  
   unsigned int cFSem;            //  
   bool         cCompuls;         //   
   char         cSector;          // 
   char         cCateg[cCategSz]; // 
   unsigned int cWH;              //   
   unsigned int cUnits;           //  
   CourseKey    cPrereq;          // 
   unsigned int cNoOfStudents;    // . 
}; // Course

typedef Course*  PCourse;

bool operator!=( const Course::CourseKey& lhs,
                 const Course::CourseKey& rhs )
{  return ( strcmp(lhs.s, rhs.s) != 0 );  }

bool operator==( const Course::CourseKey& lhs,
                 const Course::CourseKey& rhs )
{  return ( !(lhs != rhs) );  }
/*
bool operator!=( const Course& lhs, const Course& rhs )
{  return ( strcmp(lhs.getCode(), rhs.getCode()) != 0 );  }
*/
bool operator!=( const Course& lhs, const Course& rhs )
{  return ( Course::CourseKey(lhs.getCode()) !=
            Course::CourseKey(rhs.getCode()) );  }

bool operator==( const Course& lhs, const Course& rhs )
{  return ( !(lhs != rhs) );  }

struct CourseXptn
{
   enum { keyLen, rangeError, noSuchSector, noSuchCateg, autoRef,
          noStudent, fileNotOpen, cannotWrite,
          cannotRead };
   Course::CourseKey objKey; 
   char              methodName[100];
   int               errorCode;
   char              errStrVal[100];
   int               errIntVal;
   CourseXptn( const Course::CourseKey& obk, const char* mn,
               int ec, const char* sv="" )
      : objKey( obk ),  errorCode( ec )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  }
   CourseXptn( const Course::CourseKey& obk, const char* mn, int ec,
               int iv )
      : objKey( obk ),  errorCode( ec ),  errIntVal( iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  }
}; // CourseXptn

#endif // _COURSE_H
